// Arduino IDE preprocessor bug prevent - insert me on top of your arduino-code
#if 1

#ifndef _595_h
#define _595_h

#if ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
#endif


#include <FastArduino.h>
#ifndef USE_FASTARDUINO
 #warning USE_FASTARDUINO not defined in hc595

#endif


#ifndef _FastArduino_h
#warning fast not defined inside hc595.h
  #define FastdigitalWrite(a,b) digitalWrite(a,b)
  #define FastshiftOut(a,b,c,d) shiftOut(a,b,c,d)
#endif


#define SetBackLight(a,b,c) Lcd_SetFreePin(a,b,c)
#define DisplayClean(a) SendLcdCommand(LCD595_DISPLAY_CLEAR,a);

#define LCD595_DISPLAY_CLEAR 1

//accensione / spegnimento display
#define LCD595_DISPLAY_ON_CB 15
#define LCD595_DISPLAY_ON_C 14
#define LCD595_DISPLAY_ON_B 13
#define LCD595_DISPLAY_ON 12
#define LCD595_DISPLAY_OFF 8

//initdisplay
#define LCD595_BASIC_DISPLAY_INIT 32
#define LCD595_USEFONT_5X10 4
#define LCD595_MORELINES 8





class hc595
{
 private:
   unsigned char latchPin;
   unsigned char clockPin;
   unsigned char dataPin;

    unsigned char * p_Latch;
    //unsigned char * p_Clock;
    //unsigned char * p_Data;

   unsigned char b_Latch;
   //unsigned char b_Clock;
   //unsigned char b_Data;


public:
  unsigned char * Buffer;
  unsigned char num_595;

  hc595(unsigned char,unsigned char,unsigned char,unsigned char);
  void PulseE(unsigned char );
  void Send595(void);

  void Set595Pin(bool,bool,bool,bool,bool,bool,bool,bool,unsigned char);
  void Set595Pin(unsigned char ,unsigned char);
  void Send595Pin(unsigned char,unsigned char);

  void SetLcdPin(bool,bool,bool,bool,unsigned char);

  void DisplayReset(unsigned char,unsigned char);

  void DisplayWrite(const char *,unsigned char);
  void DisplayChar(unsigned char ,unsigned char );

  void CreateChar(unsigned char ,unsigned char[],unsigned char );

  void SetLcdRS(bool,unsigned char);
  void SetHLcd(unsigned char,unsigned char);
  void SetLLcd(unsigned char,unsigned char);
  void SendLcdCommand(unsigned char,unsigned char);


  void SetCursor(unsigned char, unsigned char,unsigned char, unsigned char);
  void SetDDRAM_Address(unsigned char,unsigned char );


  void Lcd_SetFreePin(unsigned char, bool,unsigned char);


inline void  DirectdigitalWrite(unsigned char , unsigned char * ,unsigned char );

  //void DirectshiftOut(const unsigned char );

 //~hc595();

};




#endif
#endif
